#include "list.h"
void push(node_t** head, element n)
{
	node_t* node = (node_t*)malloc(sizeof(node_t));
	node->val = n;
	node->next = *head;
	*head = node;
}

element pop(node_t** head) 
{
    element retval = -1;
    node_t* next_node = NULL;

    if (*head == NULL)
        return -1;

    next_node = (*head)->next;
    retval = (*head)->val;
    free(*head);
    *head = next_node;

    return retval;
}
node_t* get_tail(node_t* head)
{
	node_t* tail = head;
	while (tail->next != NULL) {
		tail = tail->next;
	}
	return tail;
}
void insert_tail(node_t** head, element n)
{
	node_t* tail = get_tail(*head);
	node_t* node = (node_t*)malloc(sizeof(node_t));
	node->val = n;
	node->next = NULL;
    if (*head == NULL)
        *head = node;
    else
    	tail->next = node;
}
element remove_tail(node_t** head) {
    element retval = 0;
    /* ḮƮ Ұ    */
    if ((*head)->next == NULL) {
        retval = (*head)->val;
        free(*head);
        *head = NULL;
        return retval;
    }

    /*    ̵Ѵ. */
    node_t* current = *head;
    while (current->next->next != NULL) {
        current = current->next;
    }

    /*  current   ̹Ƿ current->next ϸ ȴ. */
    retval = current->next->val;
    free(current->next);
    current->next = NULL;
    return retval;
}
element remove_by_index(node_t** head, int n) {
    int i = 0;
    element retval = -1;
    node_t* current = *head;
    node_t* temp_node = NULL;

    if (n == 0) {
        return pop(head);
    }

    for (i = 0; i < n - 1; i++) {
        if (current->next == NULL) {
            return -1;
        }
        current = current->next;
    }

    temp_node = current->next;
    retval = temp_node->val;
    current->next = temp_node->next;
    free(temp_node);

    return retval;
}
element remove_by_value(node_t** head, element val) {
    element retval = -1;
    node_t* current = *head;
    node_t* temp_node = NULL;

    if ((*head)->val == val)
        return pop(head);

    while (current->next != NULL && current->next->val != val) {
        current = current->next;
    }
    if (current->next == NULL)
        return -1;

    temp_node = current->next;
    retval = temp_node->val;
    current->next = temp_node->next;
    free(temp_node);

    return retval;
}
void print_list(node_t* head)
{
    node_t* current = head;
    printf("[LIST] ");
    while (current != NULL) {
        printf("%d ", current->val);
        current = current->next;
    }
    printf("\n");
}